namespace CD14Roma_EF.Migrations
{
    using System;
    using System.Data.Entity.Migrations;
    
    public partial class Startup : DbMigration
    {
        public override void Up()
        {
            CreateTable(
                "dbo.Arguments",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Description = c.String(nullable: false, maxLength: 255),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "dbo.Sessions",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Title = c.String(nullable: false, maxLength: 255),
                        StartAt = c.DateTime(nullable: false, storeType: "smalldatetime"),
                        Duration = c.Double(nullable: false),
                        Description = c.String(maxLength: 1000),
                        ArgumentID = c.Int(nullable: false),
                        SpeakerModel_Id = c.Int(),
                        SpeakerID = c.Int(nullable: false),
                        ArgumentModel_Id = c.Int(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.Arguments", t => t.ArgumentID, cascadeDelete: true)
                .ForeignKey("dbo.Speakers", t => t.SpeakerModel_Id)
                .ForeignKey("dbo.Speakers", t => t.SpeakerID)
                .ForeignKey("dbo.Arguments", t => t.ArgumentModel_Id)
                .Index(t => t.ArgumentID)
                .Index(t => t.SpeakerModel_Id)
                .Index(t => t.SpeakerID)
                .Index(t => t.ArgumentModel_Id);
            
            CreateTable(
                "dbo.Enrollments",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        AttendeeID = c.Int(),
                        SessionID = c.Int(),
                    })
                .PrimaryKey(t => t.Id)
                .ForeignKey("dbo.Attendees", t => t.AttendeeID)
                .ForeignKey("dbo.Sessions", t => t.SessionID)
                .Index(t => t.AttendeeID)
                .Index(t => t.SessionID);
            
            CreateTable(
                "dbo.Attendees",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        Email = c.String(nullable: false, maxLength: 255, unicode: false),
                        UserName = c.String(nullable: false, maxLength: 50, unicode: false),
                        Password = c.String(nullable: false, maxLength: 255),
                        FirstName = c.String(nullable: false, maxLength: 50),
                        LastName = c.String(nullable: false, maxLength: 50),
                    })
                .PrimaryKey(t => t.Id);
            
            CreateTable(
                "dbo.Speakers",
                c => new
                    {
                        Id = c.Int(nullable: false, identity: true),
                        FirstName = c.String(nullable: false, maxLength: 50),
                        LastName = c.String(nullable: false, maxLength: 50),
                    })
                .PrimaryKey(t => t.Id);
            
        }
        
        public override void Down()
        {
            DropForeignKey("dbo.Sessions", "ArgumentModel_Id", "dbo.Arguments");
            DropForeignKey("dbo.Sessions", "SpeakerID", "dbo.Speakers");
            DropForeignKey("dbo.Sessions", "SpeakerModel_Id", "dbo.Speakers");
            DropForeignKey("dbo.Enrollments", "SessionID", "dbo.Sessions");
            DropForeignKey("dbo.Enrollments", "AttendeeID", "dbo.Attendees");
            DropForeignKey("dbo.Sessions", "ArgumentID", "dbo.Arguments");
            DropIndex("dbo.Enrollments", new[] { "SessionID" });
            DropIndex("dbo.Enrollments", new[] { "AttendeeID" });
            DropIndex("dbo.Sessions", new[] { "ArgumentModel_Id" });
            DropIndex("dbo.Sessions", new[] { "SpeakerID" });
            DropIndex("dbo.Sessions", new[] { "SpeakerModel_Id" });
            DropIndex("dbo.Sessions", new[] { "ArgumentID" });
            DropTable("dbo.Speakers");
            DropTable("dbo.Attendees");
            DropTable("dbo.Enrollments");
            DropTable("dbo.Sessions");
            DropTable("dbo.Arguments");
        }
    }
}
