namespace CD14Roma_EF.Migrations
{
    using CD14Roma_EF.Models;
    using System;
    using System.Data.Entity;
    using System.Data.Entity.Migrations;
    using System.Linq;

    internal sealed class Configuration : DbMigrationsConfiguration<CD14Roma_EF.Data.ApplicationDbContext>
    {
        public Configuration()
        {
            AutomaticMigrationsEnabled = false;
        }

        protected override void Seed(CD14Roma_EF.Data.ApplicationDbContext context)
        {
            var desposito = new SpeakerModel { FirstName = "Dino", LastName = "Esposito" };
            var egjeci = new SpeakerModel { FirstName = "Eva", LastName = "Gjeci" };
            var rmessora = new SpeakerModel { FirstName = "Roberto", LastName = "Messora" };
            var ccavalli = new SpeakerModel { FirstName = "Corrado", LastName = "Cavalli" };
            var fbaldassarri = new SpeakerModel { FirstName = "Francesco", LastName = "Baldassarri" };
            var ncarandini = new SpeakerModel { FirstName = "Nicol", LastName = "Carandini" };
            var dbenvegnu = new SpeakerModel { FirstName = "Davide", LastName = "Benvegn" };
            var ppialorsi = new SpeakerModel { FirstName = "Paolo", LastName = "Pialorsi" };
            var gmricci = new SpeakerModel { FirstName = "Gian Maria", LastName = "Ricci" };
            var maponte = new SpeakerModel { FirstName = "Michele", LastName = "Aponte" };
            var gdinardo = new SpeakerModel { FirstName = "Giorgio", LastName = "Di Nardo" };
            var mbonanni = new SpeakerModel { FirstName = "Massimo", LastName = "Bonanni" };
            context.Speakers.AddOrUpdate(
                s => s.LastName,
                desposito, egjeci, rmessora, ccavalli, fbaldassarri, ncarandini, dbenvegnu, ppialorsi, gmricci, maponte, gdinardo, mbonanni
            );

            var alm = new ArgumentModel { Description = "ALM" };
            var aspNet = new ArgumentModel { Description = "ASP.NET" };
            var azure = new ArgumentModel { Description = "Azure" };
            var signalR = new ArgumentModel { Description = "SignalR" };
            var spa = new ArgumentModel { Description = "SPA" };
            var webApi = new ArgumentModel { Description = "WebAPI" };
            var winJs = new ArgumentModel { Description = "WinJS" };
            var xamarin = new ArgumentModel { Description = "Xamarin" };

            context.Arguments.AddOrUpdate(
                a => a.Description, alm, aspNet, azure, signalR, webApi, winJs, xamarin
            );

            var all05 = new SessionModel { Argument = aspNet, Duration = 50, Speaker = desposito, StartAt = new DateTime(2014, 09, 25, 10, 20, 0), Title = "ASP.NET vNext" };
            var all06 = new SessionModel { Argument = azure, Duration = 50, Speaker = egjeci, StartAt = new DateTime(2014, 09, 25, 11, 10, 0), Title = "Il cloud di Microsoft con Azure" };
            var web02 = new SessionModel { Argument = spa, Duration = 60, Speaker = rmessora, StartAt = new DateTime(2014, 09, 25, 13, 30, 0), Title = "Single Page Application" };
            var xam01 = new SessionModel { Argument = xamarin, Duration = 60, Speaker = ccavalli, StartAt = new DateTime(2014, 09, 25, 13, 30, 0), Title = "Xamarin Forms: app per iOS, Android e Windows Phone" };
            var asp01 = new SessionModel { Argument = signalR, Duration = 60, Speaker = ncarandini, StartAt = new DateTime(2014, 09, 25, 14, 30, 0), Title = "Web in real time con SignalR" };
            var asp02 = new SessionModel { Argument = webApi, Duration = 60, Speaker = gdinardo, StartAt = new DateTime(2014, 09, 25, 14, 30, 0), Title = "Realizzare il back-end della tua applicazione con Web API" };
            var vs03 = new SessionModel { Argument = alm, Duration = 60, Speaker = dbenvegnu, StartAt = new DateTime(2014, 09, 25, 14, 30, 0), Title = "Da TFS a Visual Studio Online" };
            var azu02 = new SessionModel { Argument = azure, Duration = 60, Speaker = gdinardo, StartAt = new DateTime(2014, 09, 25, 15, 45, 0), Title = "Pubblicare SharePoint app su Microsoft Azure" };
            var xam02 = new SessionModel { Argument = xamarin, Duration = 60, Speaker = gdinardo, StartAt = new DateTime(2014, 09, 25, 15, 45, 0), Title = "Sviluppare app per iOS e Android con Xamarin e Visul Studio" };
            var vs04 = new SessionModel { Argument = alm, Duration = 60, Speaker = gdinardo, StartAt = new DateTime(2014, 09, 25, 15, 45, 0), Title = "TFS: quale source control?" };
            context.Sessions.AddOrUpdate(
                s => s.Title,
                all05, all06, web02, xam01, asp01, asp02, vs03, azu02, xam02, vs04
            );

            var lucarossi = new AttendeeModel { FirstName = "Luca", LastName = "Rossi", Email = "a@a.it", UserName = "lucarossi", Password = "Pa$$w0rd" };
            var paolobianchi = new AttendeeModel { FirstName = "Paolo", LastName = "Bianchi", Email = "a@a.it", UserName = "paolobianchi", Password = "Pa$$w0rd" };
            var francoverdi = new AttendeeModel { FirstName = "Franco", LastName = "Verdi", Email = "a@a.it", UserName = "francoverdi", Password = "Pa$$w0rd" };
            context.Attendees.AddOrUpdate(
                a => a.UserName,
                lucarossi, paolobianchi, francoverdi
            );

            context.Enrollments.AddOrUpdate(
                e => e.Id,
                new EnrollmentModel { Session = asp02, Attendee = lucarossi },
                new EnrollmentModel { Session = asp02, Attendee = paolobianchi },
                new EnrollmentModel { Session = asp01, Attendee = lucarossi },
                new EnrollmentModel { Session = asp02, Attendee = francoverdi }
            );
            //  This method will be called after migrating to the latest version.

            //  You can use the DbSet<T>.AddOrUpdate() helper extension method 
            //  to avoid creating duplicate seed data. E.g.
            //
            //    context.People.AddOrUpdate(
            //      p => p.FullName,
            //      new Person { FullName = "Andrew Peters" },
            //      new Person { FullName = "Brice Lambson" },
            //      new Person { FullName = "Rowan Miller" }
            //    );
            //
        }
    }
}
