﻿using CD14Roma_EF.Models;
using Microsoft.Data.Edm;
using Newtonsoft.Json.Serialization;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http.Formatting;
using System.Web.Http;
using System.Web.Http.OData.Builder;
using System.Web.Http.OData.Extensions;

namespace CD14Roma_OData
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            config.Routes.MapODataServiceRoute(
                "DefaultOData",
                "OData",
                GenerateEdmModel()
            );

            var jsonFormatter = config.Formatters.OfType<JsonMediaTypeFormatter>().First();
            jsonFormatter.SerializerSettings.ContractResolver = new CamelCasePropertyNamesContractResolver();
        }

        private static IEdmModel GenerateEdmModel()
        {
            var builder = new ODataConventionModelBuilder();
            builder.EntitySet<ArgumentModel>("Arguments");
            var attendee = builder.EntitySet<AttendeeModel>("Attendees");
            attendee.EntityType.Ignore(e => e.UserName);
            attendee.EntityType.Ignore(e => e.Password);
            builder.EntitySet<EnrollmentModel>("Enrollments");
            builder.EntitySet<SpeakerModel>("Speakers");
            builder.EntitySet<SessionModel>("Sessions");
            return builder.GetEdmModel();
        }
    }
}
